Package owl.automaton

## Class ImplicitNonDeterministicEdgeTreeAutomaton<S,​A extends OmegaAcceptance>

- java.lang.Object
- - owl.automaton.AbstractCachedStatesAutomaton<S,​A>
  - - owl.automaton.AbstractImplicitAutomaton<S,​A>
    - - owl.automaton.ImplicitNonDeterministicEdgeTreeAutomaton<S,​A>

- All Implemented Interfaces:
    `Automaton<S,​A>`, `EdgeTreeAutomatonMixin<S,​A>`

      public class ImplicitNonDeterministicEdgeTreeAutomaton<S,​A extends OmegaAcceptance>
      extends AbstractImplicitAutomaton<S,​A>
      implements EdgeTreeAutomatonMixin<S,​A>

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface owl.automaton.Automaton

      `Automaton.EdgeMapVisitor<S>, Automaton.EdgeTreeVisitor<S>, Automaton.EdgeVisitor<S>, Automaton.PreferredEdgeAccess, Automaton.Property, Automaton.Visitor<S>`

  - ### Field Summary

    - ### Fields inherited from class owl.automaton.AbstractImplicitAutomaton

      `acceptance, factory, initialStates`

    - ### Fields inherited from interface owl.automaton.EdgeTreeAutomatonMixin

      `ACCESS_MODES`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ImplicitNonDeterministicEdgeTreeAutomaton​(ValuationSetFactory factory, Collection<S> initialStates, A acceptance, BiFunction<S,​BitSet,​Set<Edge<S>>> edgesFunction, Function<S,​ValuationTree<Edge<S>>> edgeTreeFunction)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Set<Edge<S>>` | `edges​(S state, BitSet valuation)` | Returns the successor edges of the specified `state` under the given `valuation`.
    `ValuationTree<Edge<S>>` | `edgeTree​(S state)` | Returns a decision-tree with nodes labelled by literals and sets of edges as leaves.

    - ### Methods inherited from class owl.automaton.AbstractImplicitAutomaton

      `acceptance, factory, initialStates, onlyInitialState`

    - ### Methods inherited from class owl.automaton.AbstractCachedStatesAutomaton

      `accept, accept, accept, cache, states`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface owl.automaton.Automaton

      `accept, accept, accept, accept, acceptance, edge, factory, initialStates, is, name, onlyInitialState, predecessors, size, states, successor, successors, successors`

    - ### Methods inherited from interface owl.automaton.EdgeTreeAutomatonMixin

      `edgeMap, edges, preferredEdgeAccess`

- - ### Constructor Detail

    - #### ImplicitNonDeterministicEdgeTreeAutomaton

          public ImplicitNonDeterministicEdgeTreeAutomaton​(ValuationSetFactory factory,
                                                           Collection<S> initialStates,
                                                           A acceptance,
                                                           @Nullable
                                                           BiFunction<S,​BitSet,​Set<Edge<S>>> edgesFunction,
                                                           Function<S,​ValuationTree<Edge<S>>> edgeTreeFunction)

  - ### Method Detail

    - #### edges

          public Set<Edge<S>> edges​(S state,
                                    BitSet valuation)

      Description copied from interface: `Automaton`
      Returns the successor edges of the specified `state` under the given `valuation`.
      Specified by:
        `edges` in interface `Automaton<S,​A extends OmegaAcceptance>`
      Specified by:
        `edges` in interface `EdgeTreeAutomatonMixin<S,​A extends OmegaAcceptance>`
      Parameters:
        `state` - The starting state of the transition.
        `valuation` - The valuation.
      Returns:
        The successor edges, possibly empty.

    - #### edgeTree

          public ValuationTree<Edge<S>> edgeTree​(S state)

      Description copied from interface: `Automaton`
      Returns a decision-tree with nodes labelled by literals and sets of edges as leaves.
      Specified by:
        `edgeTree` in interface `Automaton<S,​A extends OmegaAcceptance>`
      Parameters:
        `state` - The state.
      Returns:
        A tree.